"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
var strats = Object.create(null);
// 默认合并策略
function defaultStrat(val1, val2) {
    return typeof val2 !== 'undefined' ? val2 : val1;
}
function fromVal2Strat(val1, val2) {
    if (typeof val2 !== undefined) {
        return val2;
    }
}
function deepMergeStrat(val1, val2) {
    if (_1.isPlainObject(val2)) {
        return _1.deepMerge(val1, val2);
    }
    else if (typeof val2 !== 'undefined') {
        return val2;
    }
    else if (_1.isPlainObject(val1)) {
        return _1.deepMerge(val1);
    }
    else {
        return val1;
    }
}
var stratKeysFromVal2 = ['url', 'params', 'data', 'method'];
stratKeysFromVal2.forEach(function (key) {
    strats[key] = fromVal2Strat;
});
var stratKeysDeepMerge = ['headers', 'auth', 'proxy'];
stratKeysDeepMerge.forEach(function (key) {
    strats[key] = deepMergeStrat;
});
function isValidKey(key, obj) {
    return key in obj;
}
function mergeConfig(config1, config2) {
    if (!config2) {
        config2 = {};
    }
    var config = Object.create(null);
    for (var key in config2) {
        if (isValidKey(key, config2)) {
            mergeField(key);
        }
    }
    for (var key in config1) {
        if (isValidKey(key, config1)) {
            if (!config2[key]) {
                mergeField(key);
            }
        }
    }
    function mergeField(key) {
        var strat = strats[key] || defaultStrat;
        config[key] = strat(config1[key], config2[key]);
    }
    return config;
}
exports.default = mergeConfig;
//# sourceMappingURL=merge_config.js.map