import { AxiosRequestConfig, CancelTokenStatic, CancelTokenSource, AxiosPromise, AxiosResponse, AxiosInstance } from 'axios';
export default class Http {
    authorizationType: any;
    authorizationToken: string;
    cancelToken: CancelTokenStatic;
    source: CancelTokenSource;
    axiosIns: AxiosInstance;
    static INSTANCES: {
        [key: string]: AxiosInstance;
    };
    constructor(baseUrl: string, config?: AxiosRequestConfig);
    setAuthorizationTypeOrToken(type: any, token: any): void;
    request(opt: AxiosRequestConfig): Promise<AxiosResponse<any>>;
    abort(): void;
    get(url: string, configs?: AxiosRequestConfig): Promise<AxiosResponse<any>>;
    post(url: string, data?: any, configs?: AxiosRequestConfig): AxiosPromise;
    put(url: string, data?: any, configs?: AxiosRequestConfig): AxiosPromise;
    patch(url: string, data?: any, configs?: AxiosRequestConfig): AxiosPromise;
    delete(url: string, configs?: AxiosRequestConfig): AxiosPromise;
    static getInstances(key: string): AxiosInstance;
    static setReqInterceptor(resolve?: (config: AxiosRequestConfig) => AxiosRequestConfig, reject?: (error: any) => void): void;
    static setResInterceptor(resolve?: (res: AxiosResponse) => AxiosResponse, reject?: (error: any) => any): void;
}
